#include "main.h"
#include "menu.h"
#include "FT800.h"
#include "sim800.h"
#include <string.h>


// Globale Variablen
#define true 1
#define false 0
//extern


extern structSettings Settings;
extern structSettingsIndex SettingsIndex[];


long long ZF1;

//Amplitude
int Refline;		//dBm
int dBDIV;			//dB

char s[40]={"0"};

Active_Dialog_Function Active_Dialog = 0;
Active_Dialog_Callback_Function Active_Dialog_Callback = 0;

int AmplitudeTemp;
int *Active_Dialog_Amplitude;

Menu_Struct *Active_Menu;

static char iSettings=0; //selected Setting


Menu_Struct Main_Menu=		{
							{"StartWork", "EndWork", "-", "-", "Tools", "Settings"},0,{0,0,0,0,0,0},
/*Funktion Menuaufruf*/		{Menu_SetWeightBevor,Menu_GetWeightBevor,Menu_Goto,Menu_Goto,Menu_Goto,Menu_Set_Goto},
/*Funktion Menutext*/			{Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text},
							};

Menu_Struct Tools_Menu1=		{
													{"Test SMS", "Cal Touch", 	"Weight Zero", 	"Weight Cal", 	"1/2", 			"Main Menu"},0,{0,0,0,0,0,0},
/*Funktion Menuaufruf*/		{Menu_SendSMS,Menu_Calibrate,Menu_SetOffset, Menu_SetKFactor,Menu_Goto,Menu_Goto},
/*Funktion Menutext*/			{Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text},
							};

Menu_Struct Tools_Menu2=		{
													{"Test Email", 	"Reset", 	"-", 	"-", 	"2/2", 			"Main Menu"},0,{0,0,0,0,0,0},
/*Funktion Menuaufruf*/		{Menu_SendEmail,Menu_Reset,Menu_Goto, Menu_Goto,Menu_Goto,Menu_Goto},
/*Funktion Menutext*/			{Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text},
							};

							
	Menu_Struct Settings_Menu=		{
								{"Set", ">>", "<<", "Set Time", "Set Date", "Main Menu"},0,{0,0,0,0,0,0},
	/*Funktion Menuaufruf*/		{Menu_Set_Start, Menu_NextSetting, Menu_PreviousSetting,Menu_Set_Time_Start,Menu_Set_Date_Start,Menu_Goto_Dialog_End},
	/*Funktion Menutext*/			{Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text,Menu_Item_Text},
								};
	
								
int Menu_Init()
{
	Active_Menu = &Main_Menu;

	Main_Menu.Item[4] = &Tools_Menu1;
		Tools_Menu1.Item[4] = &Tools_Menu2;
		Tools_Menu1.Item[5] = &Main_Menu;
		Tools_Menu2.Item[4] = &Tools_Menu1;
		Tools_Menu2.Item[5] = &Main_Menu;
	
	Main_Menu.Item[5] = &Settings_Menu;
		Settings_Menu.Item[5] = &Main_Menu;
	
	Menu_Press(0);
	
	return 0;
}


int Menu_Press(int i)
{
	if (i != 0)	//wurde eine Menuetaste gedrueckt
	{
		if (i>6) 
			return -1;
		
		if (Active_Menu->Function[i-1] != 0)	//Hat aktueller Menuepunkt eine Menufunktion
		{
			Active_Menu->Function[i-1](i-1);	//Menufunktion aufrufen
		}
	}
	return 0;
}

int Menu_Draw(int inputtag)
{
	int i;

// 	//Menutexter je nach Text_Function ausgeben
// 	Active_Menu->Text_Function[0](32, 0,0,0);
// 	Active_Menu->Text_Function[1](32, 5,1,0);
// 	Active_Menu->Text_Function[2](32,10,2,0);
// 	Active_Menu->Text_Function[3](32,15,3,0);
		//Menu
	color_rgb(255,255,255);

	for (i=0; i<=6; i++)
	{
		tag(i+1);
		if (Active_Menu->Marked == (i+1)) //marked
		{
			cmd_fgcolor(30,130,30);
			if (inputtag == i+1)
				cmd_button(382, i*45, 97, 45, 16, OPT_FLAT, Active_Menu->String[i]);
			else
				cmd_button(382, i*45, 97, 45, 16, 0, Active_Menu->String[i]);
			cmd_fgcolor(30,30,130);
		}
		else			//not marked
		{
			if (inputtag == i+1)
				cmd_button(382, i*45, 97, 45, 16, OPT_FLAT, Active_Menu->String[i]);
			else
				cmd_button(382, i*45, 97, 45, 16, 0, Active_Menu->String[i]);
		}

	}
	
	return 0;
}

int Menu_Item_Text(int x, int y, int i, int drawvalue)
{
// 	GLCD_TextGoTo(x,y);
// 	GLCD_WriteText("        ",0);
// 	GLCD_TextGoTo(x,y+1);
// 	GLCD_WriteText("        ",0);
// 	GLCD_TextGoTo(x,y+2);
// 	GLCD_WriteText("        ",0);
// 	GLCD_TextGoTo(x,y+3);
// 	GLCD_WriteText("        ",0);
// 	
// 	GLCD_TextGoTo(x,y+2);
// 	GLCD_WriteText(Active_Menu->String[i],(Active_Menu->Marked == (i+1)));
	
	return 0;
}
int Menu_Goto_Dialog_End(int i)
{
	//Markierungn lschen
	Active_Menu->Marked = 0;
	if (Active_Menu->Item[i])
		Active_Menu = (Menu_Struct*) Active_Menu->Item[i];
	//Dialog beenden
	Active_Dialog = 0;
	Active_Dialog_Callback = 0;
	return 0;
}

int Menu_Goto(int i)
{
	if (Active_Menu->Item[i])
		Active_Menu = (Menu_Struct*) Active_Menu->Item[i];
	
	return 0;
}

int Blind_Item(int x, int y)
{
	return 0;
}

int Menu_Marked_Goto(int i)
{
	//Markierung Ein-Ausschalten
	if (Active_Menu->Marked == (i+1))
	{
		Active_Menu->Marked = 0;
		return 0;
	}
	else
	{
		Active_Menu->Marked = (i+1);
		return 1;
	}
}

//Tools Menu
int Menu_SendSMS(int i)
{
	MessageBoxText("Send SMS", 1);
	SendSMS("Alert\n");
	MessageBoxText(0, 0);

	return 0;
}

int Menu_SendEmail(int i)
{
	MessageBoxText("Send Email", 1);
	SendEmail("Alert\n");
	MessageBoxText(0, 0);

	return 0;
}

int Menu_Reset(int i)
{
	HAL_NVIC_SystemReset();

	return 0;
}

//Set Menu

int Menu_Set_Goto(int i)
{
	if (Active_Menu->Item[i])
		Active_Menu = (Menu_Struct*) Active_Menu->Item[i];
	
	Active_Dialog = Menu_Print_Settings;
	
	return 0;
}

int Menu_NextSetting(int i)
{
	if(iSettings <= (GetSizeofSettingsIndex()-2) )
		iSettings++;
	return 0;
}
int Menu_PreviousSetting(int i)
{
	if (iSettings)
		iSettings--;
	return 0;
}

int Menu_Print_Settings(char inputtag, char pressedtag)
{
	static char s[40]={"0"};

 	color_a(230);
 	color_rgb(40,40,40);
 	begin(RECTS);
	line_width(100);
	vertex2ii(20, 20, 0, 120);
	vertex2ii(300, 200, 0, 120);
	end();
	color_a(255);
	color_rgb(255,255,120);
	snprintf(s,40,"[%d]",iSettings);
	cmd_text(30, 30, 28, 0, s);
	cmd_text(30, 60, 28, 0, SettingsIndex[iSettings].szDescription);
	switch(SettingsIndex[iSettings].Settingstype)
	{
		case Settingschar: 
			snprintf(s,40,"%d", *(char*)SettingsIndex[iSettings].pSetting);
			break;
		case Settingsint: 
			snprintf(s,40,"%d", *(int*)SettingsIndex[iSettings].pSetting);
			break;
		case Settingslong:
			snprintf(s,40,"%ld", *(long*)SettingsIndex[iSettings].pSetting);
			break;
		case Settingsulong:
			snprintf(s,40,"%ld", *(unsigned long*)SettingsIndex[iSettings].pSetting);
			break;
		case Settingsfloat:
			snprintf(s,40,"%f", *(float*)SettingsIndex[iSettings].pSetting);
			break;
		case Settingsdouble:
			snprintf(s,40,"%f", *(double*)SettingsIndex[iSettings].pSetting);
			break;
		case Settingssz:
			snprintf(s,40,"%s", (char*)SettingsIndex[iSettings].pSetting);
			break;
	}
	color_rgb(255,255,255);
	cmd_text(30, 90, 28, 0, s);
	
	return 0;
}

int Menu_Set_Time_Start(int i)
{
	//Menu markieren
	if(Menu_Marked_Goto(i))
	{
		Active_Dialog = Dialog_Set;
		Active_Dialog_Callback = Menu_Set_Time_Callback;
	}
	else
	{
		//wenn nicht mehr aktiv
		Active_Dialog = 0;
		Active_Dialog_Callback = 0;
	}
	return 0;
}

int Menu_Set_Date_Start(int i)
{
	//Menu markieren
	if(Menu_Marked_Goto(i))
	{
		Active_Dialog = Dialog_Set;
		Active_Dialog_Callback = Menu_Set_Date_Callback;
	}
	else
	{
		//wenn nicht mehr aktiv
		Active_Dialog = 0;
		Active_Dialog_Callback = 0;
	}
	return 0;
}

int Menu_Set_Time_Callback(void)
{
	int h, m, sec;
	
	if(sscanf(s, "%2u:%2u:%2u", &h, &m, &sec)==3)
	{
		rtcTime.hour = h;
		rtcTime.min = m;
		rtcTime.sec = sec;

		LL_PWR_EnableBkUpAccess();

		if(LL_RTC_EnterInitMode(RTC)==SUCCESS)
		{
			rtc_settime(&rtcTime);
			LL_RTC_ExitInitMode(RTC);

			printf("Time Set\n");
		}

		LL_PWR_DisableBkUpAccess();

}				

	//Markierung aus
	Active_Menu->Marked = 0;
	Active_Dialog = 0;
	
	return 0;
}

int Menu_Set_Date_Callback(void)
{
	int mday, month, year, result;
			
	result = sscanf(s, "%u.%u.%u", &mday, &month, &year);
	if (result == 3)
	{
		rtcTime.mday = mday;
		rtcTime.month = month;
		rtcTime.year = year;

		LL_PWR_EnableBkUpAccess();
		
		if(LL_RTC_EnterInitMode(RTC)==SUCCESS)
		{
			rtc_settime(&rtcTime);
			LL_RTC_ExitInitMode(RTC);
			printf("Date Set\n");
		}

		LL_PWR_DisableBkUpAccess();

	}
	//Markierung aus
	Active_Menu->Marked = 0;
	Active_Dialog = 0;
	
	return 0;
}

// Set Menu
int Menu_Set_Start(int i)
{
	//Menu markieren
	if(Menu_Marked_Goto(i))
	{
		Active_Dialog = Dialog_Set;
		Active_Dialog_Callback = Menu_Set_Callback;
	}
	else
	{
		//wenn nicht mehr aktiv
		Active_Dialog = Menu_Print_Settings;
		Active_Dialog_Callback = 0;
	}
	return 0;
}


int Dialog_Set(char inputtag, char pressedtag)
{
	static char i=0;
	static char Num=1;
	static char Case=0;

	if (pressedtag)
	{
		//Eingabe
		if (pressedtag == 11)
		{
			Active_Dialog_Callback();
			i=0;
			s[0] = 0;
			return 0;
		}
		
		//Backspace auswerten
		if (pressedtag==10)
		{
			if (i>1)
			{
				i--;
				s[i] = 0;
			}
			else
			{
				i=0;
				s[i] = '0';
				s[1] = 0;
			}
		}

		//Num-ABC auswerten
		if (pressedtag==12)
		{
			if(Num)
				Num=0;
			else
				Num=1;
		}
		//CASE auswerten
		if (pressedtag==13)
		{
			if(Case)
				Case=0;
			else
				Case=1;
		}
		
		
		if ( (pressedtag>='+' && pressedtag<='z'))
		{
			s[i] = pressedtag;		//Zeichen einlesen
			//String abschlieen
			s[i+1] = 0;
			if (++i > 39)		//String zu lange?
				i=39;
		}
	}

	if(Num==1)
	{
		//Print Num Keypad
		cmd_fgcolor(30,30,130);
		color_a(255);
		cmd_keys(100,  85, 120, 30, 18, inputtag, "789");
		cmd_keys(100, 120, 160, 30, 18, inputtag, "456+");
		cmd_keys(100, 155, 160, 30, 18, inputtag, "123-");
		cmd_keys(100, 190, 120, 30, 18, inputtag, ":0.");
		
		tag(10);
		cmd_button(225, 85, 65, 30, 18, (inputtag==10)?OPT_FLAT:0, "<-");
		tag(11);
		cmd_button(225, 190, 65, 30, 18, (inputtag==11)?OPT_FLAT:0, "Enter");
		tag(12);
		cmd_button(5, 190, 65, 30, 18, (inputtag==11)?OPT_FLAT:0, "ABC");

		color_a(200);
		color_rgb(40,40,40);
		begin(RECTS);
		line_width(100);
		vertex2ii( 15, 40, 0, 120);
		vertex2ii(350, 60, 0, 120);
		end();
		color_a(255);
		color_rgb(255,255,120);
		cmd_text(20, 40, 28, 0, s);
	}
	else
	{
		if(Case)
		{
			//Print ABC Keypad
			cmd_fgcolor(30,30,130);
			color_a(255);
			cmd_keys(  5,  85, 300, 30, 18, inputtag,"QWERTZUIOP");
			cmd_keys( 15, 120, 300, 30, 18, inputtag, "ASDFGHJKL@");
			cmd_keys( 25, 155, 300, 30, 18, inputtag, "YXCVBNM,._");
			
			tag(10);
			cmd_button(310, 85, 65, 30, 18, (inputtag==10)?OPT_FLAT:0, "<-");
			tag(11);
			cmd_button(310, 190, 65, 30, 18, (inputtag==11)?OPT_FLAT:0, "Enter");

			tag(12);
			cmd_button(5, 190, 65, 30, 18, (inputtag==12)?OPT_FLAT:0, "0-9");
			
			tag(13);
			cmd_button(75, 190, 65, 30, 18, (inputtag==13)?OPT_FLAT:0, "abc");

			color_a(200);
			color_rgb(40,40,40);
			begin(RECTS);
			line_width(100);
			vertex2ii(  15, 40, 0, 120);
			vertex2ii(350, 60, 0, 120);
			end();
			color_a(255);
			color_rgb(255,255,120);
			cmd_text(20, 40, 28, 0, s);	
		}
		else
		{
			//Print ABC Keypad
			cmd_fgcolor(30,30,130);
			color_a(255);
			cmd_keys(  5,  85, 300, 30, 18, inputtag,"qwertzuiop");
			cmd_keys( 15, 120, 300, 30, 18, inputtag, "asdfghjkl@");
			cmd_keys( 25, 155, 300, 30, 18, inputtag, "yxcvbnm,._");
			
			tag(10);
			cmd_button(310, 85, 65, 30, 18, (inputtag==10)?OPT_FLAT:0, "<-");
			tag(11);
			cmd_button(310, 190, 65, 30, 18, (inputtag==11)?OPT_FLAT:0, "Enter");

			tag(12);
			cmd_button(5, 190, 65, 30, 18, (inputtag==12)?OPT_FLAT:0, "0-9");
			
			tag(13);
			cmd_button(75, 190, 65, 30, 18, (inputtag==13)?OPT_FLAT:0, "ABC");

			color_a(200);
			color_rgb(40,40,40);
			begin(RECTS);
			line_width(100);
			vertex2ii(  15, 40, 0, 120);
			vertex2ii(350, 60, 0, 120);
			end();
			color_a(255);
			color_rgb(255,255,120);
			cmd_text(20, 40, 28, 0, s);
		}
	}

	return 0;
}

int Menu_Set_Callback()
{
	switch(SettingsIndex[iSettings].Settingstype)
	{
		case Settingschar: 
			*(char*)SettingsIndex[iSettings].pSetting = (char) stoi(s);
			break;
		case Settingsint: 
			*(int*)SettingsIndex[iSettings].pSetting = stoi(s);
			break;
		case Settingslong:
			*(long*)SettingsIndex[iSettings].pSetting = stol(s);
			break;
		case Settingsulong:
			*(unsigned long*)SettingsIndex[iSettings].pSetting = stol(s);
			break;
		case Settingsfloat:
			*(float*)SettingsIndex[iSettings].pSetting = stof(s);
			break;
		case Settingsdouble:					
			*(double*)SettingsIndex[iSettings].pSetting = stod(s);
			break;
		case Settingssz:
			strcpy(SettingsIndex[iSettings].pSetting, s);
			break;
	}
			
	//Write Settings to EEPROM
	SaveSettings(&Settings);	
	//Markierung aus
	Active_Menu->Marked = 0;
	Active_Dialog = Menu_Print_Settings;
	
	return 0;
}


//Convert Funktion zu Dialog
long stol(char* s)
{

	long result;
	
	if(sscanf(s,"%ld",&result)==1)
		return result;
	else
		return 0;
}

//Convert Funktion zu Dialog
int stoi(char* s)
{
	int result;
	
	if(sscanf(s,"%d",&result)==1)
		return result;
	else
		return 0;
}

//Convert Funktion zu Dialog
float stof(char* s)
{
	float result;
	
	if(sscanf(s,"%f",&result)==1)
		return result;
	else
		return 0.0;
}

//Convert Funktion zu Dialog
float stod(char* s)
{
	float result;
	
	if(sscanf(s,"%f",&result)==1)
		return result;
	else
		return 0.0;
}
/*
int Menu_TempPlus(int i)
{
	Settings.fTempSet+=0.5f;
	SaveSettings(&Settings);
	PIDSetw (&PID, Settings.fTempSet);
	return 0;
}
int Menu_TempMinus(int i)
{
	Settings.fTempSet-=0.5f;
	SaveSettings(&Settings);
	PIDSetw (&PID, Settings.fTempSet);
	return 0;
}
*/

int Menu_SetWeightBevor(int i)
{
	Settings.fWeightBevor = fweightcalibrated;
	return 0;
}

int Menu_GetWeightBevor(int i)
{
	Settings.fWeightOffset += fweightcalibrated - Settings.fWeightBevor ;
	return 0;
}


//Tools Menu
int Menu_Calibrate(int i)
{
	FT800_SPI_ENABLE();
	FT800_Calibrate();
	unsigned long temp;
	temp=ft800memRead32(REG_CTOUCH_TRANSFORM_A);
	Settings.ulSET_REG_CTOUCH_TRANSFORM_A = temp;
	printf("TRANSFORM_A %u\n",temp);
	temp=ft800memRead32(REG_CTOUCH_TRANSFORM_B);
	Settings.ulSET_REG_CTOUCH_TRANSFORM_B = temp;
	printf("TRANSFORM_B %u\n",temp);
	temp=ft800memRead32(REG_CTOUCH_TRANSFORM_C);
	Settings.ulSET_REG_CTOUCH_TRANSFORM_C = temp;
	printf("TRANSFORM_C %u\n",temp);
	temp=ft800memRead32(REG_CTOUCH_TRANSFORM_D);
	Settings.ulSET_REG_CTOUCH_TRANSFORM_D = temp;
	printf("TRANSFORM_D %u\n",temp);
	temp=ft800memRead32(REG_CTOUCH_TRANSFORM_E);
	Settings.ulSET_REG_CTOUCH_TRANSFORM_E = temp;
	printf("TRANSFORM_E %u\n",temp);
	temp=ft800memRead32(REG_CTOUCH_TRANSFORM_F);
	Settings.ulSET_REG_CTOUCH_TRANSFORM_F = temp;
	printf("TRANSFORM_F %u\n",temp);
	FT800_SPI_DISABLE();
	SaveSettings(&Settings);
	printf("End Calibration\n");
	return 0;
}

int Menu_SetOffset(int i)
{
	Settings.lOffset = datasum;
	SaveSettings(&Settings);
	printf("Offset Saved\n");
	return 0;
}

int Menu_SetKFactor(int i)
{
	Settings.dFactor = Settings.fCalWeight / (double)(datasum - Settings.lOffset);
	SaveSettings(&Settings);
	printf("Offset Saved\n");
	return 0;
}
				
