#ifndef INC_MENU
#define INC_MENU

//MenueStruktur
typedef struct Menu
{
	const char	*String[6];
	unsigned char	Marked;
	struct Menu	*Item[6];
	int (*Function[6])(int);		//Funktion die beim Aufruf des Items ausgefhrt wird
	int (*Text_Function[6])(int, int, int, int);//Funktion die beim schreiben des Menutextes aufgerufen wird
}Menu_Struct;

typedef int (*Active_Dialog_Function)(char, char);
typedef int (*Active_Dialog_Callback_Function)(void);

int Menu_Init(void);
int Menu_Goto(int);								//Geht zum Untermenue
int Menu_Goto_Dialog_End(int i);		//Geht zum Untermen, beendet Dialog, lscht Markierung
int Menu_Marked_Goto(int);		//Markiert demarkiert Menuepunkt
int Menu_Press(int);
int Menu_Draw(int inputtag);
int Menu_Item_Text(int, int, int, int);
int Blind_Item(int, int);

int Menu_Set_Goto(int);
int Menu_Print_Settings(char inputtag, char pressedtag);

//Tools Menu
int Menu_SendSMS(int i);
int Menu_SetOffset(int i);
int Menu_SetKFactor(int i);
int Menu_SendEmail(int i);
int Menu_Reset(int i);


//Settings Menu
int Menu_Set_Start(int);
int Menu_Set_Time_Start(int);
int Menu_Set_Date_Start(int);
int Menu_Set_Time_Callback(void);
int Menu_Set_Date_Callback(void);

int Menu_NextSetting(int);
int Menu_PreviousSetting(int);
int Menu_Set_Callback(void);

int Dialog_Set(char inputtag, char pressedtag);

int Menu_Calibrate(int i);		//Calibrate Menu aufrufen

//int Menu_TempPlus(int);
//int Menu_TempMinus(int);

int Menu_SetWeightBevor(int);
int Menu_GetWeightBevor(int);

long stol(char* s);
int stoi(char* s);
float stof(char* s);
float stod(char* s);
							
#endif
